'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defineStyleComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _aphrodite = require('aphrodite');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var keys = Object.keys;


var separateStylePropsFromRest = function separateStylePropsFromRest(stylePropMap, map) {
  var props = {};
  var styleProps = {};

  keys(map).forEach(function (key) {
    var value = map[key];
    if (stylePropMap.hasOwnProperty(key)) {
      styleProps[key] = value;
    } else {
      props[key] = value;
    }
  });

  return {
    styleProps: styleProps,
    props: props
  };
};

var extractActiveStyleKeys = function extractActiveStyleKeys(props) {
  return keys(props).filter(function (key) {
    return props[key];
  });
};

/**
 * 1. Extract props specified in api from all other props
 * 2. Keep only the style props that are truthy
 */
var defineStyleComponent = exports.defineStyleComponent = function defineStyleComponent(api) {
  var possiblePropNames = keys(api);
  var staticStyleSheet = _aphrodite.StyleSheet.create(api);
  var dynamicStyles = void 0;

  var Style = function Style(_ref) {
    var tag = _ref.tag;
    var stylesFromAuthor = _ref.style;
    var children = _ref.children;

    var rest = _objectWithoutProperties(_ref, ['tag', 'style', 'children']);

    var Tag = tag || 'div';

    var _separateStylePropsFr = separateStylePropsFromRest(api, rest);

    var styleProps = _separateStylePropsFr.styleProps;
    var props = _separateStylePropsFr.props; /* [1] */

    var activeStyleKeys = extractActiveStyleKeys(styleProps); /* [2] */
    var activeStaticStyles = activeStyleKeys.map(function (key) {
      return staticStyleSheet[key];
    });

    if (stylesFromAuthor) {
      dynamicStyles = _aphrodite.StyleSheet.create({ Style: stylesFromAuthor }).Style;
    }

    var styleSheet = dynamicStyles ? [].concat(_toConsumableArray(activeStaticStyles), [dynamicStyles]) : activeStaticStyles;

    return _react2.default.createElement(
      Tag,
      _extends({}, props, { className: _aphrodite.css.apply(null, styleSheet) }),
      children
    );
  };

  Style.propTypes = possiblePropNames.reduce(function (prev, next) {
    return _extends({}, prev, _defineProperty({}, next, _react.PropTypes.bool));
  }, {});

  return Style;
};