'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ava = require('ava');

var _ava2 = _interopRequireDefault(_ava);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _asap = require('asap');

var _asap2 = _interopRequireDefault(_asap);

var _index = require('./index.js');

var _utils = require('./space/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

_ava2.default.serial('Ditto: spacing api applies styles as expected for Box, Row, and Col', function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(t) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _reactDom.render)(_react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _index.Box,
                _extends({ id: 'individual' }, {
                  pt: 0,
                  pr: '--',
                  pb: '-',
                  pl: true,
                  mt: true,
                  mr: '+',
                  mb: '++',
                  ml: 0
                }),
                'Hey'
              ),
              _react2.default.createElement(
                _index.Row,
                _extends({ id: 'axis' }, {
                  mx: true,
                  my: '--',
                  px: '+',
                  py: 0
                }),
                'Ho'
              ),
              _react2.default.createElement(
                _index.Col,
                _extends({ id: 'all' }, {
                  p: '++',
                  m: '-'
                }),
                'Ho'
              )
            ), document.getElementById('root'));

            (0, _asap2.default)(function () {
              applyAphroditeWorkaround(document);

              // individual
              var el = document.getElementById('individual');
              var appliedStyles = window.getComputedStyle(el);

              t.deepEqual(appliedStyles['padding-left'], (0, _utils.pxToEm)(18));
              t.deepEqual(appliedStyles['padding-bottom'], (0, _utils.pxToEm)(12));
              t.deepEqual(appliedStyles['padding-right'], (0, _utils.pxToEm)(6));
              t.deepEqual(appliedStyles['padding-top'], '0px');

              t.deepEqual(appliedStyles['margin-left'], '0px');
              t.deepEqual(appliedStyles['margin-bottom'], (0, _utils.pxToEm)(48));
              t.deepEqual(appliedStyles['margin-right'], (0, _utils.pxToEm)(30));
              t.deepEqual(appliedStyles['margin-top'], (0, _utils.pxToEm)(18));

              // Axis
              el = document.getElementById('axis');
              appliedStyles = window.getComputedStyle(el);

              t.deepEqual(appliedStyles['margin-right'], (0, _utils.pxToEm)(18));
              t.deepEqual(appliedStyles['margin-left'], (0, _utils.pxToEm)(18));
              t.deepEqual(appliedStyles['padding-left'], (0, _utils.pxToEm)(30));
              t.deepEqual(appliedStyles['padding-left'], (0, _utils.pxToEm)(30));

              t.deepEqual(appliedStyles['margin-top'], (0, _utils.pxToEm)(6));
              t.deepEqual(appliedStyles['margin-bottom'], (0, _utils.pxToEm)(6));
              t.deepEqual(appliedStyles['padding-top'], '0px');
              t.deepEqual(appliedStyles['padding-bottom'], '0px');

              // All
              el = document.getElementById('all');
              appliedStyles = window.getComputedStyle(el);

              t.deepEqual(appliedStyles['padding-left'], (0, _utils.pxToEm)(48));
              t.deepEqual(appliedStyles['padding-bottom'], (0, _utils.pxToEm)(48));
              t.deepEqual(appliedStyles['padding-right'], (0, _utils.pxToEm)(48));
              t.deepEqual(appliedStyles['padding-top'], (0, _utils.pxToEm)(48));

              t.deepEqual(appliedStyles['margin-left'], (0, _utils.pxToEm)(12));
              t.deepEqual(appliedStyles['margin-bottom'], (0, _utils.pxToEm)(12));
              t.deepEqual(appliedStyles['margin-right'], (0, _utils.pxToEm)(12));
              t.deepEqual(appliedStyles['margin-top'], (0, _utils.pxToEm)(12));

              t.pass();
            });

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());

_ava2.default.serial('Ditto: flex property is applied to Row & Col but not Box', function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(t) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            (0, _reactDom.render)(_react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _index.Box,
                { id: 'box' },
                'hey'
              ),
              _react2.default.createElement(
                _index.Row,
                { id: 'row' },
                'hey'
              ),
              _react2.default.createElement(
                _index.Col,
                { id: 'col' },
                'hey'
              )
            ), document.getElementById('root'));

            (0, _asap2.default)(function () {
              applyAphroditeWorkaround(document);
              var el = document.getElementById('box');
              var appliedStyles = window.getComputedStyle(el);
              t.not(appliedStyles.display, 'flex');

              el = document.getElementById('col');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.display, 'flex');

              el = document.getElementById('row');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.display, 'flex');
              t.pass();
            });

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x2) {
    return _ref2.apply(this, arguments);
  };
}());

_ava2.default.serial('Row, Col: x & y props apply style properties as expected', function () {
  var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(t) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            (0, _reactDom.render)(_react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _index.Row,
                { id: 'cx', x: true },
                'Hi'
              ),
              _react2.default.createElement(
                _index.Col,
                { id: 'absolute-center', x: true, y: true },
                'Hi'
              ),
              _react2.default.createElement(
                _index.Row,
                { id: 'row-end', x: 'end', y: true },
                'Ho'
              ),
              _react2.default.createElement(
                _index.Col,
                { id: 'col-end', x: true, y: 'end' },
                'Ho'
              )
            ), document.getElementById('root'));

            (0, _asap2.default)(function () {
              applyAphroditeWorkaround(document);
              var el = document.getElementById('cx');
              var appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.justifyContent, 'center');
              t.not(appliedStyles.alignItems, 'center');

              el = document.getElementById('absolute-center');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.alignItems, 'center');
              t.is(appliedStyles.justifyContent, 'center');

              el = document.getElementById('row-end');
              appliedStyles = window.getComputedStyle(el);
              t.not(appliedStyles.alignItems, 'flex-end');
              t.is(appliedStyles.justifyContent, 'flex-end');

              el = document.getElementById('col-end');
              appliedStyles = window.getComputedStyle(el);
              t.not(appliedStyles.alignItems, 'flex-end');
              t.is(appliedStyles.justifyContent, 'flex-end');

              t.pass();
            });

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function (_x3) {
    return _ref3.apply(this, arguments);
  };
}());

_ava2.default.serial('Row, Col: space & wrap props apply style properties as expected', function () {
  var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(t) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            (0, _reactDom.render)(_react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(_index.Row, { id: 'no-wrap' }),
              _react2.default.createElement(
                _index.Row,
                { id: 'around-wrap', x: true, space: 'around', wrap: true },
                'Hi'
              ),
              _react2.default.createElement(
                _index.Col,
                { id: 'between-reverse', space: 'between', wrap: 'reverse' },
                'Hi'
              )
            ), document.getElementById('root'));

            (0, _asap2.default)(function () {
              applyAphroditeWorkaround(document);
              var el = document.getElementById('no-wrap');
              var appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.flexWrap, undefined);

              el = document.getElementById('around-wrap');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.justifyContent, 'space-around');
              t.is(appliedStyles.flexWrap, 'wrap');

              el = document.getElementById('between-reverse');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.justifyContent, 'space-between');
              t.is(appliedStyles.flexWrap, 'wrap-reverse');

              t.pass();
            });

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function (_x4) {
    return _ref4.apply(this, arguments);
  };
}());

_ava2.default.serial('Box, Row, Col: sizing api applies styles as expected', function () {
  var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(t) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            (0, _reactDom.render)(_react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(_index.Box, { id: 'size', width: '20px', height: '20em' }),
              _react2.default.createElement(
                _index.Row,
                { id: 'max-size', maxWidth: '20em', maxHeight: '20px' },
                'Hi'
              ),
              _react2.default.createElement(
                _index.Col,
                { id: 'min-size', minWidth: '20px', minHeight: '20em' },
                'Hi'
              )
            ), document.getElementById('root'));

            (0, _asap2.default)(function () {
              applyAphroditeWorkaround(document);
              var el = document.getElementById('size');
              var appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.width, '20px');
              t.is(appliedStyles.height, '20em');

              el = document.getElementById('max-size');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.maxWidth, '20em');
              t.is(appliedStyles.maxHeight, '20px');

              el = document.getElementById('min-size');
              appliedStyles = window.getComputedStyle(el);
              t.is(appliedStyles.minWidth, '20px');
              t.is(appliedStyles.minHeight, '20em');

              t.pass();
            });

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function (_x5) {
    return _ref5.apply(this, arguments);
  };
}());

function logDom(document) {
  console.log(document.documentElement.outerHTML.split('<').join('\n<').split('>').join('>\n'));
}

function insertStyleTag(document, content) {
  var style = document.createElement('style');

  style.type = 'text/css';
  if (style.styleSheet) {
    style.styleSheet.cssText = content;
  } else {
    style.appendChild(document.createTextNode(content));
  }
  document.head.appendChild(style);
}

var cleanUpStyles = function cleanUpStyles(document) {
  var head = document.getElementsByTagName('head')[0];

  while (head.hasChildNodes() && document.getElementsByTagName('style').length > 1) {
    head.removeChild(head.lastChild);
  }
};

function applyAphroditeWorkaround(document) {
  cleanUpStyles(document);
  var styleTags = document.getElementsByTagName('style');
  var aphroStyles = styleTags[styleTags.length - 1].textContent;
  insertStyleTag(document, aphroStyles);
}